;==================================
; program to test the io : copy input (PORT D) to output (portB)
; robot ISIA 2001 - Space Odyssee
; www-isia.cma.fr/~robotm6/
; target = at90s1200, 8MHz
; compiled with avr studio from Atmel
;==================================

.include "1200def.inc"

;========================
; define variable
;========================
.def 	Tmp	= r16
.def	outputreg = r17

;========================
; interrupt vector table
;========================
.cseg	;CODE segment
.org $000 ; reset
	rjmp __reset_
.org INT0addr ; external interrupt
	reti
.org OVF0addr ; timer overflow
	reti
.org ACIaddr ; analogic converter interrupt
	reti


;========================
; program init
;========================	
__reset_:
;define port direction
;input = D
	ldi Tmp, 0x00
	out DDRD,Tmp
; set mode to pull-up -> PIND default value = 1, 
; +5V --[__ R=10KO __]-- * --|(C=4.7uF)|-- * --Gnd
;			 |	           |
;		 PIND -- * ---*/ inter *-- *
	ldi Tmp, 0xff
	out PORTD,Tmp
;output = B
	ldi Tmp, 0xff
	out DDRB, Tmp
;output off
	clr outputreg
	out PORTB, outputreg
;initialiser interruptions : disable all
	ldi Tmp,0x00
	out GIMSK, Tmp ; external int
	ldi Tmp,0x00
	out TIMSK, Tmp ; timer int
;enable interupts
	sei
;fin, commence le code
	rjmp start
	
;======================
; code : copy input to output
;======================
start:
	in outputreg,PIND
	out PORTB,outputreg
	rjmp start
	